# Electron + Vite + Typescript Project Template

<p align="center">
  <img width="100px" src="https://upload.wikimedia.org/wikipedia/commons/thumb/9/91/Electron_Software_Framework_Logo.svg/1024px-Electron_Software_Framework_Logo.svg.png">
  <img width="100px" src="https://i.2kvn.com/img/vib-2021-logo.svg">
</p>

<p align="center">
  <img src="https://img.shields.io/badge/Electron-^13.1.7-brightgreen?style=plastic&logo=electron">
  <img src="https://img.shields.io/badge/Vite-%5E2.4.3-brightgreen?style=plastic&logo=vite">
</p>

> 👻 A fast Simple Vite 2, popular front-end frameworks and Electron 13.x template. This template should help get you started developing with Vite 2, popular front-end frameworks and Typescript in Electron.

## Links

- 📘 Documentation: [Coming soon](https://github.com/trantoan960/electron-vite-template)
- 👥 Community: [Join us](https://www.facebook.com/groups/chiasekienthuclaptrinhrhpteam/)
- 🎬 Video: [1 minute demo](https://github.com/trantoan960/electron-vite-template)

## Why I should be use?

- Dev runner, performance for develop environment
- Production builder faster
- Stats info for development environment
- Secured your code on production
- Support full Typescript =))
- Support popular framework for renderer process.

## Features

- Automatic update new version
- Performance electron builder
- Pre-load window in production env
  
## How to Use

> **Compatibility Note:**
> Vite requires [Node.js](https://nodejs.org/en/) version >=12.0.0.

### Option 1: ⚡️ It's as simple as that! So easy by command line:

With NPM:

```bash
$ npm init ev@latest
```

With Yarn:

```bash
$ yarn create ev
```

With PNPM:

```bash
$ pnpx create-ev
```

Then follow the prompts!

You can also directly specify the project name and the template you want to use via additional command line options. For example, to scaffold a Vite + Vue/React/... project, run:

```bash
# npm 6.x
npm init ev@latest my-vue-app --template vue
############# OR #############
npm init ev@latest my-react-app --template react

# npm 7+, extra double-dash is needed:
npm init ev@latest my-vue-app -- --template vue
############# OR #############
npm init ev@latest my-react-app -- --template react

# yarn
yarn create ev my-vue-app --template vue
############# OR #############
yarn create ev my-react-app --template react

# pnpm
pnpx create-ev my-vue-app --template vue
############# OR #############
pnpx create-ev my-react-app --template react
```

Currently supported template presets include:

- `vanilla` - Coming soon
- `vanilla-ts` - Coming soon
- `vue` - Coming soon
- `vue-ts`
- `react` - Coming soon
- `react-ts`

### Option 2: Clone the package folder repository `packages/create-ev/templates`.

## Run Dev

🔥 Hot runner dev env

```sh
yarn dev
```

## Build package

Built-in Windows, Mac, Linux. Please read more details in package.json scripts

```sh
<!-- Build production -->
yarn build

<!-- Build production for Windows x64 -->
yarn build:win64
```

## Security

If you discover a security vulnerability regarding this template, please send an e-mail via trantoan.fox.97@gmail.com! All security vulnerabilities will be promptly addressed.

## Show me your apps!
If you've built any applications with our template, we'd love to see them!.

## License

[MIT](https://github.com/trantoan960/electron-vite-template/blob/dev-ts/LICENSE)
